%This file creates the dataset
%4 sources with knowen emission rate and location,  and 9 sensors,  located
%downwind
%each grid cell is 300x300 meters.



clearvars;
clc;
close all;
clear all;
svAPI = API;
configFile = Configuration;

sizeOfStudyArea = configFile.GRID_SIZE;

studyArea = zeros(sizeOfStudyArea,sizeOfStudyArea);
scale =1;

x_source1 = 1*scale;
y_source1 = 3*scale;
Q_source1 = 8e+6;

x_source2 = 1*scale;
y_source2 = 7*scale;
Q_source2 = 7e+6;

x_source3 = 2*scale;
y_source3 = 6*scale;
Q_source3 = 5e+6;

x_source4 = 3*scale;
y_source4 = 5*scale;
Q_source4 = 6e+6;



windSpeed  = configFile.WIND_SPEED; % m/sec
windDirection  =  configFile.WIND_DIRECTION;

sourceArray = [x_source1, y_source1, Q_source1; x_source2, y_source2, Q_source2; x_source3, y_source3, Q_source3; x_source4, y_source4, Q_source4];

x_sensor1 = 5;
y_sensor1 = 3;

x_sensor2 = 5;
y_sensor2 = 8;

x_sensor3 = 6;
y_sensor3 = 2;

x_sensor4 = 6;
y_sensor4 = 6;

x_sensor5 = 7;
y_sensor5 = 1;

x_sensor6 = 7;
y_sensor6 = 5;

x_sensor7 = 8;
y_sensor7 = 4;

x_sensor8 = 8;
y_sensor8 = 6;
%

x_sensor9 = 9;
y_sensor9 = 7;




sensorArray = [x_sensor1,y_sensor1;x_sensor2,y_sensor2;x_sensor3,y_sensor3; x_sensor4,y_sensor4;x_sensor5,y_sensor5; x_sensor6,y_sensor6 ;x_sensor7,y_sensor7 ; x_sensor8,y_sensor8;
    x_sensor9,y_sensor9 ];

for i=1:size(sensorArray)
    totalAmbientDataOfSensor = 0;
    for j=1:size(sourceArray)
        ambientDataFromOneSource = svAPI.calculateSensorCon(sensorArray(i,1), sensorArray(i,2), sourceArray(j,1), sourceArray(j,2), sourceArray(j,3));
        totalAmbientDataOfSensor  = totalAmbientDataOfSensor + ambientDataFromOneSource;
    end
    sensorArray(i,3) = totalAmbientDataOfSensor;
end

%plot data
figure;
for i=1:size(sourceArray)
    hold on
    plot(sourceArray(i,1), sourceArray(i,2), '*r')
    %text(sourceArray(i,1),sourceArray(i,2)+0.3,num2str(sourceArray(i,3)));
end

axis([0 sizeOfStudyArea+2 0 sizeOfStudyArea+2]);
for i=1:size(sensorArray)
    hold on
    plot(sensorArray(i,1), sensorArray(i,2), '-mo')
    %text(sensorArray(i,1),sensorArray(i,2)+0.3,num2str(sensorArray(i,3)));
end

grid on
set(gcf,'color','w');
set(gca,'Xtick',0 : .5 : 12);
set(gca,'Ytick',0 : .5 : 12);
xticklabels({0,'',1,'',2,'',3,'',4,'',5,'',6,'',7,'',8,'',9,'',10,'',11,'',12});
yticklabels({0,'',1,'',2,'',3,'',4,'',5,'',6,'',7,'',8,'',9,'',10,'',11,'',12});
set(gca,'FontSize',17);

