%create spatial map of pollution (interpolation map) based on the sources
%locations and emissions
%1. get the location of the sources
%2. calculate the averge emisson, based on sensors measurments
%3. for each cell in the grid, set a 'grade' (ambient pollution) based on
%the gaussian model (using average wind speed and direction of all sensors)
%4. plot the grid.

%
now1 = {'Start run on:', datestr(now)}
clear all;
close all;
clearvars;
svAPI = API;
configFile = Configuration;

%in this class, the paramters at the config file must be changed: 
%GRID_SIZE = 1200
%GRID_SCALE = 3

sizeOfStudyArea = configFile.GRID_SIZE;

studyArea = zeros(sizeOfStudyArea,sizeOfStudyArea);
scale = 100;

x_source1 = 1*scale;
y_source1 = 3*scale;
Q_source1 = 8e+6;

x_source2 = 1*scale;
y_source2 = 7*scale;
Q_source2 = 7e+6;

x_source3 = 2*scale;
y_source3 = 6*scale;
Q_source3 = 5e+6;

x_source4 = 3*scale;
y_source4 = 5*scale;
Q_source4 = 6e+6;


sourceArray = [x_source1, y_source1, Q_source1;x_source2, y_source2, Q_source2; x_source3, y_source3, Q_source3; x_source4, y_source4, Q_source4];

domain  = zeros(sizeOfStudyArea, sizeOfStudyArea);

for i=1:sizeOfStudyArea
    
    for j=1:sizeOfStudyArea
        totalAmbientDataOfSingleGridCell = 0;
        for k=1:size(sourceArray)
            ambientDataFromOneSource = svAPI.calculateSensorCon(i,j, sourceArray(k,1), sourceArray(k,2), sourceArray(k,3));
            totalAmbientDataOfSingleGridCell  = ambientDataFromOneSource + totalAmbientDataOfSingleGridCell;
        end
        domain(j,i) = totalAmbientDataOfSingleGridCell;
        
    end
    
end



figure;
hold on;
set(gcf,'color','w');
imagesc(domain.^0.3);%((domain.^0.1));

for k =1:size(sourceArray)
    temp_source = sourceArray(k, :);
    
    %plot the source
    plot(temp_source(1,1), temp_source(1,2), '*y');
end

% colorbar;
colormap('jet');


x_sensor1 = 8;
y_sensor1 = 6;

x_sensor2 = 6;
y_sensor2 = 2;

x_sensor3 = 9;
y_sensor3 = 7;

x_sensor4 = 7;
y_sensor4 = 5;

x_sensor5 = 5;
y_sensor5 = 3;

x_sensor6 = 7;
y_sensor6 = 1;

x_sensor7 = 6;
y_sensor7 = 6;

x_sensor9 = 8;
y_sensor9 = 4;

x_sensor10 = 5;
y_sensor10 = 8;


sensorArray = [x_sensor1,y_sensor1;x_sensor2,y_sensor2;x_sensor3,y_sensor3; x_sensor4,y_sensor4;x_sensor5,y_sensor5; x_sensor6,y_sensor6 ;x_sensor7,y_sensor7 ; %x_sensor8,y_sensor8;
    x_sensor9,y_sensor9 ;x_sensor10,y_sensor10]*scale;


for i=1:size(sensorArray)
    hold on
    plot(sensorArray(i,1), sensorArray(i,2), '-mo')
    %     text(sensorArray(i,1),sensorArray(i,2)+0.3);%,num2str(sensorArray(i,3)));
end
now1 = {'Ends run on:', datestr(now)}




