%This is the main class of the model. it manage all the process to locate
%the last source, with known emission rate and unknown location.
clear all;
close all;
clc;
now1 = {'Start run on:', datestr(now)}


%call for objects
svAPI = API;
configFile = Configuration;
fs = FindSources;
sizeOfStudyArea = configFile.GRID_SIZE;


% sensorArray  - the output from CreatData.m  -  the sensors location and
% measured data
sensorArray = [5,3,165.037766815523;5,8,8.01692775060986;6,2,16.0783124073157;6,6,119.019052095078;7,1,0.395126476185231;7,5,134.568132473007;8,4,34.3603475055052;8,6,85.1368359277499;9,7,60.2351860025290];%[7,1,0.395126476185231;9,7,60.2351860025290;7,9,0.345794285516911;5,4,9.21625148161018;6,6,119.019052095078;8,2,22.0449739347712;5,8,8.01692775060986]


[numOfsensors, ~] =  size(sensorArray);



%create "static" map of the n-1 sources
%the estimated emission rate is a guess or based on prior knowledge.
gridCellSource1 = cell(sizeOfStudyArea,sizeOfStudyArea);
for i=1:sizeOfStudyArea
    for j=1:sizeOfStudyArea
        source1_grid = fs.getAmbientDataGrid(i,j,8e+6);
        gridCellSource1{j,i} = source1_grid;
    end
end

gridCellSource2 = cell(sizeOfStudyArea,sizeOfStudyArea);
for i=1:sizeOfStudyArea
    for j=1:sizeOfStudyArea
        source2_grid = fs.getAmbientDataGrid(i,j,7e+6);
        gridCellSource2{j,i} = source2_grid;
    end
end

gridCellSource3 = cell(sizeOfStudyArea,sizeOfStudyArea);
for i=1:sizeOfStudyArea
    for j=1:sizeOfStudyArea
        source3_grid = fs.getAmbientDataGrid(i,j,5e+6);
        gridCellSource3{j,i} = source3_grid;
    end
end




% the last source.  calculate estimated emission rate based on each sensor
% measurement
gridCellSource_Last = cell(sizeOfStudyArea,sizeOfStudyArea);
for  s=1:numOfsensors
    
    current_sensor = sensorArray(s,:);
    sensor_x = current_sensor(1,1);
    sensor_y = current_sensor(1,2);
    sensor_mes = current_sensor(1,3);
    
    for a=1:sizeOfStudyArea
        for b=1:sizeOfStudyArea
            for c=1:sizeOfStudyArea
                for d=1:sizeOfStudyArea
                    for e=1:sizeOfStudyArea
                        for f=1:sizeOfStudyArea
                            
                            contAllSources = gridCellSource1{b,a}(sensor_y, sensor_x) + gridCellSource2{d,c}(sensor_y, sensor_x) + gridCellSource3{f,e}(sensor_y, sensor_x);
                            contOfLAstSource = sensor_mes - contAllSources;
                            gridEmissionMatrix = fs.getGridEmissionData(sensor_x, sensor_y, contOfLAstSource);
                            for i=1:sizeOfStudyArea
                                for j = 1:sizeOfStudyArea
                                    gridCellSource_Last{b,a}{d,c}{f,e}{numOfsensors+1,1}{i,j}(1,s) = gridEmissionMatrix(i,j);
                                end
                            end
                        end
                    end
                end
            end
        end
    end
    
end


now1 = {'After first stage:', datestr(now)}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% this section is for calculating the STD of the sensors measuremnts.

%round up the  number of valid sensor
numOfValidSensors = ceil(numOfsensors*(2/3));
STDGrid  =zeros (sizeOfStudyArea, sizeOfStudyArea);

for a=1:sizeOfStudyArea
    for b=1:sizeOfStudyArea
        for c=1:sizeOfStudyArea
            for d=1:sizeOfStudyArea
                for e=1:sizeOfStudyArea
                    for f=1:sizeOfStudyArea
                        lastSensorGrid = gridCellSource_Last{b,a}{d,c}{f,e}{numOfsensors+1,1};
                        for i=1:sizeOfStudyArea
                            for j = 1:sizeOfStudyArea
                                
                                lastSensorGrid{i,j}(lastSensorGrid{i,j}<=0) =[];
                                [~, actualNumOfValidSensors] = size (lastSensorGrid{i,j});
                                if actualNumOfValidSensors >= numOfValidSensors
                                    STDGrid(i,j)= std(lastSensorGrid{i,j});
                                else
                                    STDGrid(i,j) = NaN;
                                end
                                
                            end
                        end
                        
                        gridCellSource_Last{b,a}{d,c}{f,e}{numOfsensors+2,1} = STDGrid;
                        
                    end
                end
            end
        end
    end
end


now1 = {'After second stage:', datestr(now)}


%%%find the cell with the lowest STD
% [M,I] = min((gridCellSource3{1,1}{2,2}{3,3}{5,1}(:)))
totalMin = 1e+10;
Ifinal = -1;
for a=1:sizeOfStudyArea
    for b=1:sizeOfStudyArea
        for c=1:sizeOfStudyArea
            for d=1:sizeOfStudyArea
                for e=1:sizeOfStudyArea
                    for f=1:sizeOfStudyArea
                        [M,I] = min(gridCellSource_Last{b,a}{d,c}{f,e}{numOfsensors+2,1}(:));
                        if totalMin>M
                            totalMin = M;
                            Ifinal = I;
                            final = [a,b,c,d,e,f];
                        end
                        %
                    end
                end
            end
        end
    end
end

[I_row, I_col] = ind2sub(size(gridCellSource_Last),Ifinal)

final,I_row, I_col
%the std value
totalMin

%the value of the cell:
% mean(gridCellSource_Last{b,a}{d,c}{f,e}{numOfsensors+1,1}[I_row, I_col])

now1 = {'Ends on:', datestr(now)}
